<?php
namespace Tests\Functional\App\Http\Controllers\Api;

use App\Traits\TemporaryDirectory;
use Tests\TestCase;

/**
 * Generated by PHPUnit_SkeletonGenerator on 2015-11-11 at 17:40:07.
 */
class StorageControllerTest extends TestCase
{
    use TemporaryDirectory;

    /**
     * Setup the test environment.
     *
     * @return void
     */
    public function setUp()
    {
        putenv('STORAGE_DEFAULT=local');
        putenv('STORAGE_PATH='.$this->getTemporaryDirectory());

        parent::setUp();
    }

     /**
     * Clean up the testing environment before the next test.
     *
     * @return void
     */
    public function tearDown()
    {
        $this->deleteTemporaryDirectory();

        parent::tearDown();
    }
    /**
     * Storage Provider fo tests
     *
     * @return array
     */
    public function storageProvider()
    {
        return [
            ['a.txt', 'body'],
            ['b.txt', 'body'],
            ['c.txt', 'boasdy'],
        ];
    }

    /**
     * @covers App\Http\Controllers\Api\StorageController::store
     * @dataProvider storageProvider
     */
    public function testStore($path, $body)
    {
        $this->store($path, $body);
    }

    protected function store($path, $body)
    {
        $this->post(
            '/'.config('api_path').'/storage/'.$path,
            ['body' => $body]
        )
            ->seeJson([
                'error' => false,
                'saved' => true,
            ]);
    }

    /**
     * @covers App\Http\Controllers\Api\StorageController::store
     * @covers App\Http\Controllers\Api\StorageController::show
     * @dataProvider storageProvider
     */
    public function testShow($path, $body)
    {
        $this->store($path, $body);
        $this->get(
            '/'.config('api_path').'/storage/'.$path
        )
            ->seeJson([
                'error' => false,
                'body' => $body,
            ]);
    }

    /**
     * @covers App\Http\Controllers\Api\StorageController::store
     * @covers App\Http\Controllers\Api\StorageController::destroy
     * @dataProvider storageProvider
     */
    public function testDestroy($path, $body)
    {
        $this->store($path, $body);
        $this->delete(
            '/'.config('api_path').'/storage/'.$path
        )
            ->seeJson([
                'error' => false,
                'deleted' => true,
            ]);
    }
}
